DCMTK: DcmOverlayData Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | List of all members
DcmOverlayData Class Reference

a class used to represent overlay data (60xx,3000) More...

Inheritance diagram for DcmOverlayData:

## Public Member Functions
| DcmOverlayData (const DcmTag &tag, const Uint32 len=0)
| constructor
| DcmOverlayData (const DcmOverlayData &oldObj)
| copy constructor
virtual | ~DcmOverlayData ()
| destructor
DcmOverlayData & | operator= (const DcmOverlayData &obj)
| copy assignment operator
virtual DcmObject * | clone () const
| clone method
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying.
virtual DcmEVR | ident () const
| return identifier for this class.
Public Member Functions inherited from DcmPolymorphOBOW
| DcmPolymorphOBOW (const DcmTag &tag, const Uint32 len=0)
| constructor
| DcmPolymorphOBOW (const DcmPolymorphOBOW &old)
| copy constructor
virtual | ~DcmPolymorphOBOW ()
| destructor
DcmPolymorphOBOW & | operator= (const DcmPolymorphOBOW &obj)
| copy assignment operator
virtual int | compare (const DcmElement &rhs) const
| Comparison operator that compares the normalized value of this element with a given element of the same type (e.g.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc, const Uint32 maxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| This function writes this element's value to the outstream which was passed.
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual void | transferEnd ()
| finalize the transfer state of this object.
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16.
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued).
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued).
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it.
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it.
Public Member Functions inherited from DcmOtherByteOtherWord
| DcmOtherByteOtherWord (const DcmTag &tag)
| constructor.
| DcmOtherByteOtherWord (const DcmOtherByteOtherWord &old)
| copy constructor
virtual | ~DcmOtherByteOtherWord ()
| destructor
DcmOtherByteOtherWord & | operator= (const DcmOtherByteOtherWord &obj)
| assignment operator
virtual OFCondition | checkValue (const OFString &vm="", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element
virtual OFCondition | setVR (DcmEVR vr)
| set/change the current value representation
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print the current value to a stream.
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check whether the transfer syntax can be changed as specified
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format to a stream
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format to a stream
virtual OFCondition | getUint8 (Uint8 &byteVal, const unsigned long pos=0)
| get particular 8 bit value.
virtual OFCondition | getUint16 (Uint16 &wordVal, const unsigned long pos=0)
| get particular 16 bit value.
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a particular value as a character string.
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get element value as a character string.
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string.
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string.
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmElement (const DcmElement &old)
| copy constructor
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory
virtual OFCondition | clear ()
| clear (remove) attribute value
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16.
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32.
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32.
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32.
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64.
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64.
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64.
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey.
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16.
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32.
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32.
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32.
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64.
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64.
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64.
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object).
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued).
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value.
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value.
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value.
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value.
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value.
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value.
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value.
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued).
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued).
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued).
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued).
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued).
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file.
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again.
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image.
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object.
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching.
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching.
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching.
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
virtual DcmItem * | getParentItem ()
| get parent item of this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet)
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR)
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR)
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM)
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string.
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM)
Protected Member Functions inherited from DcmOtherByteOtherWord
| DcmOtherByteOtherWord (const DcmTag &tag, const Uint32 len)
| constructor.
virtual void | postLoadValue ()
| method is called after the element value has been loaded.
OFCondition | alignValue ()
| align the element value to an even length (padding)
void | printPixel (STD_NAMESPACE ostream &out, const size_t flags, const int level, const char *pixelFileName, size_t *pixelCounter)
| print pixel data and optionally write it to a binary file.
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value.
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value.
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size.
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this.
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array.
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class used to represent overlay data (60xx,3000)

## Constructor & Destructor Documentation

## ◆ DcmOverlayData() [1/2]

DcmOverlayData::DcmOverlayData | ( | const DcmTag & | tag,
|  | const Uint32 | len = 0 )
| inline

constructor

Parameters

  tag | attribute tag
  len | length of the attribute value

References DcmPolymorphOBOW::DcmPolymorphOBOW().

Referenced by DcmOverlayData(), clone(), copyFrom(), and operator=().

## ◆ DcmOverlayData() [2/2]

DcmOverlayData::DcmOverlayData | ( | const DcmOverlayData & | oldObj | ) |
| inline

copy constructor

Parameters

  oldObj | element to be copied

References DcmOverlayData(), and DcmPolymorphOBOW::DcmPolymorphOBOW().

## Member Function Documentation

## ◆ clone()

virtual DcmObject * DcmOverlayData::clone | ( |  | ) | const
| inlinevirtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmPolymorphOBOW.

References DcmOverlayData().

## ◆ copyFrom()

virtual OFCondition DcmOverlayData::copyFrom | ( | const DcmObject & | rhs | ) |
| inlinevirtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmPolymorphOBOW.

References DcmOverlayData(), EC_IllegalCall, EC_Normal, DcmObject::ident(), and ident().

## ◆ ident()

virtual DcmEVR DcmOverlayData::ident | ( | void |  | ) | const
| inlinevirtual

return identifier for this class.

Every class derived from this class returns a unique value of type enum DcmEVR for this call. This is used as a "poor man's RTTI" to correctly identify instances derived from this class even on compilers not supporting RTTI.

Returns
  type identifier of this class

Reimplemented from DcmOtherByteOtherWord.

References EVR_OverlayData.

Referenced by copyFrom().

## ◆ operator=()

DcmOverlayData & DcmOverlayData::operator= | ( | const DcmOverlayData & | obj | ) |
| inline

copy assignment operator

Parameters

  obj | element to be copied

Returns
  reference to this object

References DcmOverlayData(), and DcmPolymorphOBOW::operator=().

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcovlay.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2